# PHP wrapper for the GRPC interfaces.

## LAYOUT

Directory structure is as generated by the PHP utility
[ext_skel](http://php.net/manual/en/internals2.buildsys.skeleton.php)

## ENVIRONMENT

Install `php5` and `php5-dev`.

To run the tests, additionally install `php5-readline` and `phpunit`.

Alternatively, build and install PHP 5.5 or later from source with standard
configuration options.

To also download and install protoc and the PHP code generator.

```bash
apt-get install -y procps
curl -sSL https://get.rvm.io | sudo bash -s stable --ruby
git clone git@github.com:google/protobuf.git
cd protobuf
./configure
make
make install
git clone git@github.com:murgatroid99/Protobuf-PHP.git
cd Protobuf-PHP
rake pear:package version=1.0
pear install Protobuf-1.0.tgz
```

## BUILDING

 1. In ./ext/grpc, run the command `phpize` (distributed with PHP)
 2. Run `./ext/grpc/configure`
 3. In ./ext/grpc, run `make` and `sudo make install`
 4. In your php.ini file, add the line `extension=grpc.so` to load the
    extension at PHP startup.

## PHPUnit

This repo now has PHPUnit tests, which can by run by executing
`./bin/run_tests.sh` after building.

There is also a generated code test (`./bin/run_gen_code_test.sh`), which tests
the stub `./tests/generated_code/math.php` against a running localhost server
serving the math service. That stub is generated from
`./tests/generated_code/math.proto`.
